# cert-status-exporter

A Prometheus exporter that checks the expiry and validity of configured domains
once a day.

## Usage

To export certificate status metrics, run `cert-status-exporter --domain <domain>:<port>:<alpn>[:<name>]`.
The format means: "Connect to `<domain>` on port `<port>` while advertising `<alpn>` as ALPN during the
TLS negotiations. If `<name>` is specified, then the metric will be labeled as `<name>`, instead of `<domain>`.
`<alpn>` is a semi-colon separated list of ALPN protocols.

By default, `cert-status-exporter` will bind to `0.0.0.0:8888` and expose the metrics at `0.0.0.0:8888/metrics`. To change
the binding address, you can specify `--host` and `--port` to change how `cert-status-exporter` binds the socket.

### Example

- `cert-status-exporter --host 127.0.0.1 --port 8383 --domain "gnu.org:443:http/1.1;http/1.0;http/0.9"`: Check the certificate of `gnu.org:443`, while presenting the HTTP ALPN protocol names during the TLS negotiation. The metrics are exported with the label `name` equal to `gnu.org`.
- `cert-status-exporter --domain "example.org:5223:xmpp-client:xmpp"`: Check the certificate of `example.org:5223`, while presenting `xmpp-client` as the  ALPN protocol during the TLS negotiation. Moreover, export the certificate state with the label `name` equal to `xmpp`.

## License

See `LICENSE`.